unit PhoeniXLib;

interface

uses DXInpUtil;

type
  PInputs=^TInputs;
  {$PACKENUM 1}
  TTextureMode=(tmDecal,tmModulate,tmBlend,tmReplace);
  TTextureFilter=(tfLinear,tfNearest,tfMMLinear,tfMMNearest);
  TTextureCompressionQuality=(tcqNone,tcqRGB_DXT1,tcqRGBA_DXT1,tcqRGBA_DXT3,tcqRGBA_DXT5);
  TButtonState=(bsNormal,bsDown,bsEnabled,bsDisabled);
  TButtonChanges=(bchEnable,bchDisable,bchMouseDown,bchMouseUp);
  TCursorChanges=(cchDown,cchUp,cchDClick,cchMove);
  TButtonType=(btStandart,btCheckBox);
  TSliderType=(stSlider,stProgress,stSliderProgress);
  TEffectType=(etHalo,etFire,etFireEx,etParticles,etBlur,etTail);
  TShortEffectType=(setUser,setFade,setShake);
  TParentSpriteType=(pstEasySprite,pstSpriteEx,pstAnimSprite,pstUserObject);
  TClient_wnd_proc=procedure(msg,wparam,lparam:dword);stdcall;
  TParticlesProc=procedure(particles:pointer; length,time:dword; var added_particle_pointer:dword);stdcall;
  PCursorSprite=^TCursorSprite;
  TCursorChangesProc=procedure(cur:PCursorSprite);stdcall;
  TButtonChangesProc=procedure(state:TButtonChanges);stdcall;
  TSliderChangesProc=procedure(position:byte);stdcall;
  TUserProc=procedure(data:dword);stdcall;
  TInputs_proc=procedure(delta_time:cardinal);stdcall;
  TTimer_proc=procedure(delta_time:cardinal);stdcall;
  TRender_proc=procedure(ind:byte);stdcall;
  TClose_func=function:boolean;stdcall;
  TCallProcs=array[0..3] of pointer;//   client_wnd_proc ; render_proc ; inputs_proc ; close_func
  PCallProcs=^TCallProcs;
  TPhXLPoint=record
    x,y:single;
  end;
  TPhXLVector=TPhXLPoint;
  TPhXLRect=record
    x,y,w,h:single;
  end;
  TPhXLRect2=record
    left,top,right,bottom:single;
  end;
  TPHXLColor=record
    r,g,b,a:single;
  end;
  TInputs=record
   keyboard:array [0..255] of Byte;
   dwX,dwY,dwZ:dword;
   btn0,btn1:boolean;
   JoysticInited:boolean;
   js:DIJOYSTATE2;
   mx,my:word;
   btn0_,btn1_:boolean;
  end;

  TOutPort=record
    x,y,w,h:LongInt;
    index:byte;
    sleep:word;
    left,right,bottom,top:Double;
    worked:boolean;
    fps,var_frames,var_time,var_time2,new_time,delta_time:cardinal;
  end;
  POutPort=^TOutPort;

  PTexture=^TTexture;

  TParticle=record
    position,xy_speed,xy_acceleration,width_height:TPhXLPoint;
    scale,scale_speed,angle,angle_speed:single;
    color1,color2:TPHXLColor;
    life_time,birth_time,frame:dword;
    enabled:boolean;
  end;
  PParticle=^TParticle;

  TEffect=record
    render_first,generate,x_random,y_random,particle_attenuation:boolean;
    effect_type:TEffectType;
    parts_count,frame_count:dword;
    particles:array of TParticle;
    radius,particle_radius,scale_speed:single;
    position,xy_speed:TPhXLPoint;
    life_time,interval,time:dword;
    color1,color2:TPHXLColor;
    texture:PTexture;
    added_particle_pointer:dword;
    arr_beam_coords:array of TPhXLPoint;
    user_proc1,user_proc2:pointer;
  end;
  PEffect=^TEffect;

  TShortEffect=record
    effect_type:TShortEffectType;
    time,birth_time,duration,interval,freq:dword;
    render_first,enabled:boolean;
    onProgress,onStop:TUserProc;
    user_data:dword;
    color1,color2:TPHXLColor;
    rect:TPhXLRect2;
    point:TPhXLPoint;
  end;
  PShortEffect=^TShortEffect;

  TEasySprite=record
      x,y,w,h:single;
      z:byte;
      texture:PTexture;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
  end;
  PEasySprite=^TEasySprite;
  TSpriteEx=record
      x,y,w,h:single;
      z:byte;
      texture:PTexture;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
      angle:single;
      x1,y1,x2,y2,x3,y3,x4,y4:single;
      engine_calc:boolean;
      r,g,b,a:single;
      tex_x,tex_y,tex_w,tex_h:single;
  end;
  PSpriteEx=^TSpriteEx;
  TAnimSprite=record
      x,y,w,h:single;
      z:byte;
      texture:PTexture;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
      angle:single;
      x1,y1,x2,y2,x3,y3,x4,y4:single;
      engine_calc:boolean;
      r,g,b,a:single;
      frames_hor,frames_vert,curr_frame,frame_count:word;
      frame_time:integer;
      first_frame,last_frame:word;
      anim_type:(atLoopForward,atLoopBack,atOneForward,atOneBack,atOneShotForward,atNone);
      time:dword;
  end;
  PAnimSprite=^TAnimSprite;

  TUserObject=record
      x,y,w,h:single;
      z:byte;
      user_proc:TUserProc;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
      angle:single;
  end;
  PUserObject=^TUserObject;

     TFont=record
       texture:PTexture;
       char_first,char_last:word;
       chars_hor,chars_vert:word;
       tex_ch_w,tex_ch_h:single;
       chars_coodr_arr_length:word;
       chars_coord:PChar;
     end;
     PFont=^TFont;

      TCursorSprite=record
       x,y,w,h:single;
       z:byte;
       texture:PTexture;
       effects_enable:boolean;
       effects:array [0..2] of PEffect;
       angle:single;
       frames_hor,frames_vert,curr_frame,frame_count:word;
       frame_time:integer;
       first_frame,last_frame:word;
       time:dword;
       visible:boolean;
       enabled:boolean;
       proc:TCursorChangesProc;
       last_change:TCursorChanges;
     end;

     TTextSprite=record
       x,y,ch_w,ch_h:single;
       z:byte;
       text:PChar;
       font:PFont;
       text_length:longint;
       dx,dy:single;
       r,g,b,a:single;
       r2,g2,b2,a2:single;
       blink_time:word;
       blink_var:longint;
       centered:boolean;
     end;
     PTextSprite=^TTextSprite;

     TButtonSprite=record
       x,y,ch_w,ch_h:single;
       z:byte;
       text:PChar;
       font:PFont;
       text_length:longint;
       dx,dy:single;
       texture:PTexture;
       state_count:byte;
       state:TButtonState;
       proc_change:TButtonChangesProc;
       b_type:TButtonType;
       w,h:single;
       r,g,b,a:single;
       r2,g2,b2,a2:single;
     end;
     PButtonSprite=^TButtonSprite;

     TSliderSprite=record
       x,y,w,h:single;
       z:byte;
       texture:PTexture;
       RatioParts:byte;
       position:byte;
       angle:single;
       sl_type:TSliderType;
       proc_change:TSliderChangesProc;
       dynamic_part_first:boolean;
     end;
     PSliderSprite=^TSliderSprite;

     TTexture=record
      arrTex:pointer;
      w,h:DWORD;
      blend:boolean;
      filter:TTextureFilter;
      texture_mode:TTextureMode;
      texId:cardinal;
      imageid:cardinal;
     end;

const PhXL='PhoeniXLib.dll';

  PHXL_ON_TOP=1;
  PHXL_FULL_SCREEN=2;
  PHXL_HIDE_CURSOR=4;
  PHXL_NOCLEAR_COLOR_BUFFER=8;
  PHXL_CHANGE_SCREEN_RESOLUTION=16;
  PHXL_USE_DEVIL=32;
  PHXL_INPUTS_THREAD=64;
  PHXL_USE_DXINPUT=128;
  PHXL_VSYNC=256;
  PHXL_USE_GUI=512;

function phxlInit(opt:word;procs:PCallProcs;x,y,w,h:integer;capt:PChar;inputTimer:cardinal):cardinal;stdcall;external PhXL name'phxlInit';
function phxlInit2(opt:word;procs:PCallProcs;x,y,w,h:integer;parent:dword;inputTimer:dword):dword;stdcall;external PhXL name'phxlInit2';
procedure phxlStart;stdcall;external PhXL name'phxlStart';
procedure phxlRender;stdcall;external PhXL name'phxlRender';
procedure phxlExit;stdcall;external PhXL name'phxlExit';

procedure phxlSetZLevelsCount(count: byte);stdcall;external PhXL name'phxlSetZLevelsCount';
procedure phxlGetWorldCoord(x, y: Smallint; out xo, yo: single);stdcall;external PhXL name'phxlGetWorldCoord';
function phxlGetMainOutPort:POutPort;stdcall;external PhXL name'phxlGetMainOutPort';
function phxlGetInputs: PInputs;stdcall;external PhXL name'phxlGetInputs';
procedure phxlApplyMainOutPortChanges;stdcall;external PhXL name'phxlApplyMainOutPortChanges';
function phxlAddOutPort(x, y, w, h: integer; sleep: word): POutPort;stdcall;external PhXL name'phxlAddOutPort';
procedure phxlWriteLogString(str:string;open,close:boolean);stdcall;external PhXL name'phxlWriteLogString';

function phxlAddTimer(sync:boolean;proc:TTimer_proc;time:cardinal):integer;stdcall;external PhXL name'phxlAddTimer';
procedure phxlDeleteTimer(index:integer);stdcall;external PhXL name'phxlDeleteTimer';

function phxlAddEasySprite(x,y:single):PEasySprite;stdcall;external PhXL name'phxlAddEasySprite';
procedure phxlDeleteEasySprite(spr:PEasySprite);stdcall;external PhXL name'phxlDeleteEasySprite';
procedure phxlClearEasySprites;stdcall;external PhXL name'phxlClearEasySprites';
function phxlAddSpriteEx(x,y:single):PSpriteEx;stdcall;external PhXL name'phxlAddSpriteEx';
procedure phxlDeleteSpriteEx(spr:PSpriteEx);stdcall;external PhXL name'phxlDeleteSpriteEx';
procedure phxlClearExSprites;stdcall;external PhXL name'phxlClearExSprites';
function phxlAddAnimSprite(x,y:single):PAnimSprite;stdcall;external PhXL name'phxlAddAnimSprite';
procedure phxlDeleteAnimSprite(spr:PAnimSprite);stdcall;external PhXL name'phxlDeleteAnimSprite';
procedure phxlClearAnimSprites;stdcall;external PhXL name'phxlClearAnimSprites';
function phxlAddUserObject(z:byte;user_pr:TUserProc):PUserObject;stdcall;external PhXL name'phxlAddUserObject';
procedure phxlDeleteUserObject(uo:PUserObject);stdcall;external PhXL name'phxlDeleteUserObject';
procedure phxlClearUserObjects;stdcall;external PhXL name'phxlClearUserObjects';

function phxlEnableCursor(texture:PTexture;w,h:single):PCursorSprite;stdcall;external PhXL name'phxlEnableCursor';
function phxlAddTextSprite(text:PChar):PTextSprite;stdcall;external PhXL name'phxlAddTextSprite';
procedure phxlDeleteTextSprite(spr:PTextSprite);stdcall;external PhXL name'phxlDeleteTextSprite';
procedure phxlClearTextSprites;stdcall;external PhXL name'phxlClearTextSprites';
function phxlAddButtonSprite(x, y: single; text:PChar): PButtonSprite;stdcall;external PhXL name'phxlAddButtonSprite';
procedure phxlDeleteButtonSprite(spr:PButtonSprite);stdcall;external PhXL name'phxlDeleteButtonSprite';
procedure phxlClearButtonSprites;stdcall;external PhXL name'phxlClearButtonSprites';
function phxlAddSliderSprite(x,y:single):PSliderSprite;stdcall;external PhXL name'phxlAddSliderSprite';
procedure phxlDeleteSliderSprite(spr:PSliderSprite);stdcall;external PhXL name'phxlDeleteSliderSprite';
procedure phxlClearSliderSprites;stdcall;external PhXL name'phxlClearSliderSprites';

function phxlAddHaloEffect(parts_count:dword;radius:single;color1,color2:TPHXLColor;position:TPhXLPoint):PEffect;stdcall;external PhXL name'phxlAddHaloEffect';
function phxlAddFireEffect(radius,particle_radius:single;position,xy_speed:TPhXLPoint;parts_count,interval,life_time:dword):PEffect;stdcall;external PhXL name'phxlAddFireEffect';
function phxlAddFireExEffect(radius,particle_radius:single;position,xy_speed:TPhXLPoint;interval,life_time,frame_count:dword;texture:PTexture):PEffect;stdcall;external PhXL name'phxlAddFireExEffect';
function phxlAddParticles(generate_proc,life_proc:TParticlesProc;particle_radius:single;interval,particle_count,frame_count:dword;texture:PTexture):PEffect;stdcall;external PhXL name'phxlAddParticles';
function phxlAddBlur(blurs_count,interval:dword;scale_speed,start_alpha,end_alpha:single;speed:TPhXLPoint):PEffect;stdcall;external PhXL name'phxlAddBlur';
procedure phxlMakeExplode(particles:PEffect;life_time,dlife_time,particle_count:dword;speed,dspeed,scale_speed:single;position:TPhXLPoint);stdcall;external PhXL name'phxlMakeExplode';
procedure phxlDeleteEffect(effect:PEffect);stdcall;external PhXL name'phxlDeleteEffect';
procedure phxlClearEffects;stdcall;external PhXL name'phxlClearEffects';

procedure phxlMakeUserEvents(duration,interval,data:dword;onProgress,onStop:TUserProc);stdcall;external PhXL name'phxlMakeUserEvents';
procedure phxlMakeFadeEffect(duration:dword;color1,color2:TPHXLColor; onStop:TUserProc);stdcall;external PhXL name'phxlMakeFadeEffect';
procedure phxlMakeShakeEffect(duration,frequency:dword;max_dx,max_dy:single;random:boolean);stdcall;external PhXL name'phxlMakeShakeEffect';
procedure phxlClearShortEffects;stdcall;external PhXL name'phxlClearShortEffects';

procedure phxlProportionalImageSprite(spr: PEasySprite;width:boolean);stdcall;external PhXL name'phxlProportionalImageSprite';
function phxlPointInSprite(spr: PEasySprite; point: TPhXLPoint): boolean;stdcall;external PhXL name'phxlPointInSprite';
function phxlCollideSpritesRects(spr1,spr2:PEasySprite):boolean;stdcall;external PhXL name'phxlCollideSpritesRects';
function phxlCollideSpritesSpheres(spr1,spr2:PEasySprite;centres_distance:single):boolean;stdcall;external PhXL name'phxlCollideSpritesSpheres';
function phxlCollideSpritesSpheres2(spr1,spr2:PEasySprite;centres_distance:single;var vec:TPhXLVector):boolean;stdcall;external PhXL name'phxlCollideSpritesSpheres2';
procedure phxlSetTextToSprite(text:PChar;spr:PTextSprite);stdcall;external PhXL name'phxlSetTextToSprite';
function phxlGetTextSpriteWidth(ts:PTextSprite;text:PChar):single;stdcall;external PhXL name'phxlGetTextSpriteWidth';
procedure phxlNotifySprite(spr:PSpriteEx);stdcall;external PhXL name'phxlNotifySprite';

function phxlLoadFont(fontfilename, texturefilename: PChar):PFont;stdcall;external PhXL name'phxlLoadFont';
procedure phxlFreeFont(fnt:PFont);stdcall;external PhXL name'phxlFreeFont';

function phxlAddTexture(filename: PChar; filter:TTextureFilter; tex_mode:TTextureMode; compress:TTextureCompressionQuality; blend,free_on_load,mip_maps:boolean):PTexture;stdcall;external PhXL name'phxlAddTexture';
procedure phxlApplyTexture(tex:PTexture);stdcall;external PhXL name'phxlApplyTexture';
procedure phxlUnApplyTexture;stdcall;external PhXL name'phxlUnApplyTexture';
procedure phxlDeleteTexture(tex:PTexture);stdcall;external PhXL name'phxlDeleteTexture';
procedure phxlClearTextures;stdcall;external PhXL name'phxlClearTextures';

function PHXLColor(r,g,b,a:single):TPHXLColor;
function PHXLPoint(x,y:single):TPhXLPoint;
function PHXLRect2(left,top,right,bottom:single):TPhXLRect2;

implementation

function PHXLColor(r, g, b, a: single): TPHXLColor;
begin
  result.r:=r;
  result.g:=g;
  result.b:=b;
  result.a:=a;
end;

function PHXLPoint(x, y: single): TPhXLPoint;
begin
  result.x:=x;
  result.y:=y;
end;

function PHXLRect2(left, top, right, bottom: single): TPhXLRect2;
begin
 result.left:=left;
 result.top:=top;
 result.right:=right;
 result.bottom:=bottom;
end;


end.
